function vexpower_changeEnergyText()
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_energytext[key] ~= nil then
			vexpower_energytext[key]:SetText(vexpower_parseTagInfo(vexpower_parameters["frame"]["energy"]["text"][key]["text"]))
		end
	end
end

function vexpower_parseTagInfo(text)
	local percenergy = vexpower_getPrintablePercEnegery()
	local missingEnergy = vexpower.maxenergy-vexpower.currentenergy
	local missingCPs = vexpower.maxcps - vexpower.currentcps
	local PowerAltCurrent,PowerAltMax = vexpower_getPrintableAltPower()
	
	text = string.gsub(text, "%[PowerCurrent%]", vexpower.currentenergy)
	text = string.gsub(text, "%[PowerCurrentSmart%]", vexpower_GetEnergyShort(vexpower.currentenergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerCurrentShort%]", vexpower_GetEnergyShort(vexpower.currentenergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerMax%]", vexpower.maxenergy)
	text = string.gsub(text, "%[PowerMaxSmart%]", vexpower_GetEnergyShort(vexpower.maxenergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerMaxShort%]", vexpower_GetEnergyShort(vexpower.maxenergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerMissing%]", missingEnergy)
	text = string.gsub(text, "%[PowerMissingSmart%]", vexpower_GetEnergyShort(missingEnergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerMissingShort%]", vexpower_GetEnergyShort(missingEnergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerPerc%]", vexpower_GetEnergyShort(percenergy, false, 100))
	text = string.gsub(text, "%[PowerPercSmart%]", vexpower_GetEnergyShort(percenergy, true, 100))
	
	if vexpower.class == "MAGE" and vexpower.specType == 62 then
		text = string.gsub(text, "%[BuffDurationTotal%]", vexpower_convertText(vexpower_getDebuffTime("total")))
		text = string.gsub(text, "%[BuffDurationLeft%]", vexpower_convertText(vexpower_getDebuffTime("left")))
	else
		text = string.gsub(text, "%[BuffDurationTotal%]", vexpower_convertText(vexpower_getBuffTime("total")))
		text = string.gsub(text, "%[BuffDurationLeft%]", vexpower_convertText(vexpower_getBuffTime("left")))
	end
	text = string.gsub(text, "%[PowerAltCurrent%]", vexpower_convertText(PowerAltCurrent))
	text = string.gsub(text, "%[PowerAltMax%]", vexpower_convertText(PowerAltMax))
	
	text = string.gsub(text, "%[CPsCurrent%]", tostring(vexpower.currentcps))
	text = string.gsub(text, "%[CPsMax%]", tostring(vexpower.maxcps))
	text = string.gsub(text, "%[CPsMissing%]", tostring(missingCPs))
	return text
end

function vexpower_getPrintablePercEnegery()
	local percenergy = 0
	if vexpower.maxenergy ~= 0 then
		percenergy = (vexpower.currentenergy/vexpower.maxenergy)*100
	end
	return percenergy
end

function vexpower_getPrintableAltPower()
	local PowerAltCurrent = ""
	local PowerAltMax = ""
	if vexpower.class == "WARLOCK" and vexpower.specType == 267 then
		PowerAltCurrent = UnitPower("player", 14, true)
		if PowerAltCurrent >= 20 then
			PowerAltCurrent = PowerAltCurrent - 20
		elseif PowerAltCurrent >= 10 then
			PowerAltCurrent = PowerAltCurrent - 10
		end
		PowerAltMax = 10
	elseif vexpower.class == "WARLOCK" and vexpower.specType == 266 then
		PowerAltCurrent = UnitPower("player", 15)
		PowerAltMax = UnitPowerMax("player", 15)
	end
	return PowerAltCurrent, PowerAltMax
end

function vexpower_convertText(text)
	if text == 0 or text == "0" then
		return ""
	else
		return text
	end
end

function vexpower_GetEnergyShort(amount, smart, maximum)

	local returnvalue = ""
	if maximum < 1000 then
		amount = amount*1000
	end
	if smart then
		amount = tonumber(amount)/100
		amount = vexpower_CeilNumber(tonumber(amount))
		amount = tostring(amount / 10)
		if string.find(amount, "%.") == nil then
			amount = amount..".0"
		end
		returnvalue = amount
	else
		amount = tonumber(amount)/1000
		amount = vexpower_CeilNumber(tonumber(amount))
		returnvalue = tostring(amount)
	end
	return returnvalue
end

function vexpower_CeilNumber(amount)
	local returnvalue = ""
	amount = tostring(amount)
	if string.find(amount, "%.") ~= nil then
		local amount_l = string.gsub(amount, "%.%d+$", "")
		local amount_r = string.gsub(amount, "^%d+%.", "0.")
		amount_l = tonumber(amount_l)
		amount_r = tonumber(amount_r)
		if amount_r >= 0.5 then
			amount_l = amount_l+1
		end
		returnvalue = amount_l
	else
		returnvalue = tonumber(amount)
	end
	return returnvalue
end

function vexpower_setEnergyTextbar()
	vexpower_energyTextbar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexpower_energyTextbar:SetBackdropColor(0, 0, 0, 0)
	vexpower_energyTextbar:SetBackdropBorderColor(1,1,1,0)
	vexpower_energyTextbar:SetWidth(vexpower.maxwidth)
	vexpower_energyTextbar:SetFrameStrata("MEDIUM")
	vexpower_energyTextbar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energyTextbar:ClearAllPoints()
	vexpower_energyTextbar:SetPoint("TOPLEFT", "vexpower_energybarbg", "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
end

function vexpower_setFontStrings()
	for key in pairs(vexpower_energytext) do
		if vexpower_energytext[key] ~= nil then
			vexpower_energytext[key]:Hide()
		end
	end
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_energytext[key] ~= nil then
			vexpower_energytext[key]:Show()
			vexpower_energytext[key]:ClearAllPoints()
			vexpower_energytext[key]:SetPoint(
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor"],
				"vexpower_energyTextbar",
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"],
				vexpower_parameters["frame"]["energy"]["text"][key]["x"],
				vexpower_parameters["frame"]["energy"]["text"][key]["y"])
			vexpower_energytext[key]:SetTextColor(vexpower_parameters["frame"]["energy"]["text"][key]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["a"])
			vexpower_energytext[key]:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"][key]["font"]),
											vexpower_parameters["frame"]["energy"]["text"][key]["size"],
											vexpower_parameters["frame"]["energy"]["text"][key]["effect"])	
			vexpower_energytext[key]:SetWidth(vexpower_parameters["frame"]["energy"]["text"][key]["width"])	
			vexpower_energytext[key]:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"][key]["align"])
			if vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["allow"] then	
				vexpower_energytext[key]:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["a"])
				vexpower_energytext[key]:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["x"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["y"])
			else
				vexpower_energytext[key]:SetShadowColor(0, 0, 0, 0)
				vexpower_energytext[key]:SetShadowOffset(0, 0)
			end
		end
	end	
end	

function vexpower_createFontStrings()
	if vexpower_energytext == nil then
		vexpower_energytext = {}
	end
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_energytext[key] == nil then
			vexpower_energytext[key] = vexpower_energyTextbar:CreateFontString("vexpower_energytext["..key.."]", "OVERLAY", "GameFontNormal")
		end
	end
end