-- =======================
-- =====COLORPRESETS======
-- =======================

vexpower_colorpresets_load = {
	["1"] = {["r"]=1, ["g"]=0.929, ["b"]=0.0156, ["a"]=1},
	["2"] = {["r"]=0.7725, ["g"]=1, ["b"]=0.043, ["a"]=1},
	["3"] = {["r"]=0.314, ["g"]=1, ["b"]=0.6666, ["a"]=1},
	["4"] = {["r"]=0, ["g"]=1, ["b"]=0.753, ["a"]=1},
	["5"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
	["6"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
	["change"] = {["r"]=1, ["g"]=0, ["b"]=0, ["a"]=1},
	["used"] = {["r"]=1, ["g"]=0.6, ["b"]=0, ["a"]=1},
	}
vexpower_colorpresets_name = ""
vexpower_colorpresets_status = " "
vexpower_colorpresets_savename = ""

function vexpower_newColorPreset()
	vexpower_colorpresets_savename = "new"
	vexpower_colorpresets_name = "-"
	vexpower_colorpresets_load = {
		["1"] = {["r"]=1, ["g"]=0.929, ["b"]=0.0156, ["a"]=1},
		["2"] = {["r"]=0.7725, ["g"]=1, ["b"]=0.043, ["a"]=1},
		["3"] = {["r"]=0.314, ["g"]=1, ["b"]=0.6666, ["a"]=1},
		["4"] = {["r"]=0, ["g"]=1, ["b"]=0.753, ["a"]=1},
		["5"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
		["6"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
		["change"] = {["r"]=1, ["g"]=0, ["b"]=0, ["a"]=1},
		["used"] = {["r"]=1, ["g"]=0.6, ["b"]=0, ["a"]=1},
	}
end

function vexpower_saveColorPreset()
	local name = vexpower_colorpresets_savename
	
	if vexpower_profile_checkName(name) then
		vexpower_default_data["colorpresets"][name] = vexpower_CopyTable(vexpower_colorpresets_load)
		if vexpower_colorpresets_savename == vexpower_colorpresets_name then
			vexpower_colorpresets_status = "Successfully saved the changes of ColorPreset '"..name.."'"
		else
			vexpower_colorpresets_status = "Successfully saved the new ColorPreset '"..name.."'"
		end
	else
		if name == "" then
			vexpower_colorpresets_status = "ERROR: Couldn't save ColorPreset. You need to set a name."
		else
			vexpower_colorpresets_status = "ERROR: Couldn't save ColorPreset '"..name.."'. Invalid symbols used."
		end
	end
end

function vexpower_deleteColorPreset()
	if vexpower_colorpresets_name == "" then
		vexpower_colorpresets_status = "ERROR: Can't delete current settings"
	else
		if vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
			vexpower_default_data["colorpresets"][vexpower_colorpresets_name] = nil
			vexpower_colorpresets_status = "Successfully deleted ColorPreset '"..vexpower_colorpresets_name.."'"
		else
			vexpower_colorpresets_status = "ERROR: Couldn't delete ColorPreset '"..vexpower_colorpresets_name.."'. Preset doesn't exist"
		end
	end
end

function vexpower_loadColorPreset()
	if vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
		vexpower_parameters["frame"]["combo"]["bg"]["color"] = vexpower_CopyTable(vexpower_default_data["colorpresets"][vexpower_colorpresets_name])
		vexpower_colorpresets_status = "Successfully loaded ColorPreset '"..vexpower_colorpresets_name.."'"
	else
		vexpower_colorpresets_status = "ERROR: Couldn't load ColorPreset '"..vexpower_colorpresets_name.."'. Preset doesn't exist"
	end
end

function vexpower_getColorPresetList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_default_data["colorpresets"]) do
		if default then
			local isSet = false
			local presetFor = ""
			local count = 0
			for class,classdata in pairs(vexpower_default_data["classpresets"]) do
				if key == classdata[2] and classdata[1] then
					if count ~= 0 then
						presetFor = presetFor..", "
					end
					presetFor= presetFor..class
					count=count+1
				end
			end
			
			if count==0 then
				returnvalue[key]=key
			else
				returnvalue[key]=key.." (Default for "..presetFor..")"
			end
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	
	if default then
		returnvalue[""]="Current"
	end
	
	if timer == 0 then
		returnvalue[""] = "No profiles created"
	end
	
	return returnvalue
end

function vexpower_gatherPresetData()
	if vexpower_colorpresets_name == "" then
		vexpower_colorpresets_load = vexpower_CopyTable(vexpower_parameters["frame"]["combo"]["bg"]["color"])
	elseif vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
		vexpower_colorpresets_load = vexpower_CopyTable(vexpower_default_data["colorpresets"][vexpower_colorpresets_name])
	end
end





-- =======================
-- =====MARKERS===========
-- =======================
vexpower.new_marker_location = ""
vexpower.new_marker_spec = ""
vexpower.new_marker_powertype = {
	["FOCUS"] = true,
	["MANA"] = true,
	["RUNIC_POWER"] = true,
	["ENERGY"] = true,
	["RAGE"] = true,
	}
vexpower.marker_created = " "
vexpower.marker_deleted = " "

function vexpower_panel_getMarker(val)
	local markers = {}
	if val == "spec a" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"]
	elseif val == "spec b" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"]
	else
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	end
	
	local returnvalue = {}
	local timer = 0
	for key,val in pairs(markers) do
		local powertypes = ""
		local powertypeCount = 0
		for k,v in pairs(val) do
			if v then
				local text = ""
				if k == "FOCUS" then
					text = "F"
				elseif k == "MANA" then
					text = "M"
				elseif k == "RUNIC_POWER" then
					text = "RP"
				elseif k == "ENERGY" then
					text = "E"
				elseif k == "RAGE" then
					text = "R"
				end
				if text ~= "" then
					if powertypes ~= "" then
						powertypes = powertypes..", "
					end
					powertypes = powertypes..text
					powertypeCount = powertypeCount + 1
				end
			end
		end
		
		if powertypeCount == 5 then
			powertypes = "all powertypes"
		else
			powertypes = powertypes.." only"
		end
		
		returnvalue[key]=key.." ("..powertypes..")"
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No markers created"
	end
	
	return returnvalue
end
	
function vexpower_panel_addmarker()
	local pos = vexpower.new_marker_location
	local spec = vexpower.new_marker_spec
	
	if vexpower_panel_markercheck(pos) then
		local overwrite
		if 		spec == "" 	then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		elseif 	spec == "a" then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		elseif 	spec == "b" then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		end
		
		local specname = ""
		if spec == "a" then
			specname = "Primary Spec"
		elseif spec == "b" then
			specname = "Secondary Spec"
		else
			specname = "Both Specs"
		end
		
		if overwrite then
			vexpower.marker_created = "marker (location: "..pos..", visible for: "..specname..") has been overwritten"
		else
			vexpower.marker_created = "marker (location: "..pos..", visible for: "..specname..") successfully created"
		end
	else
		vexpower.marker_created = "ERROR --> "..pos.." <-- is not a valid 'marker' !"
	end
end

function vexpower_panel_markercheck(val)
	local returnvalue = false
	if string.gsub(val, "^%d+%%?", "") == "" then returnvalue = true end
	if val == "" then returnvalue = false end
	return returnvalue
end

function vexpower_panel_deletemarker(pos, spec)
	if spec == "" 		then vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = nil
	elseif spec == "a" 	then vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = nil
	elseif spec == "b" 	then vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = nil end
	local specname = ""
	if spec == "a" then
		specname = "Primary Spec"
	elseif spec == "b" then
		specname = "Secondary Spec"
	else
		specname = "Both Specs"
	end
	vexpower.marker_deleted = "marker (location: "..pos..", visible for: "..specname..") successfully deleted"
end





-- =======================
-- =====PROFILES==========
-- =======================
vexpower_profiles_profile_load = ""
local vexpower_profiles_profile_delete = ""
local vexpower_profiles_profile_new = GetRealmName().." "..select(1, UnitName("player"))


function vexpower_profile_add()
	local key = vexpower_profiles_profile_new
	if key ~= "" then
		vexpower_profiles[key] = vexpower_CopyTable(vexpower_parameters)
		
		vexpower_profiles_profile_new = ""
	end
end

function vexpower_getProfileList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_profiles) do
		if key ~= "profilelist" then
			if key == vexpower_default_data["profile"] and default then
				returnvalue[key]=key.." (Default Profile)"
			else
				returnvalue[key]=key
			end
			timer = timer + 1
		end
	end
	
	if timer == 0 then
		returnvalue[""] = "No profiles created"
	end
	
	return returnvalue
end

function vexpower_profile_checkName(val)
	local returnvalue = false
	local val_edited = string.gsub(val, "%a", "")
	val_edited = string.gsub(val_edited, "%d", "")
	val_edited = string.gsub(val_edited, " ", "")
	val_edited = string.gsub(val_edited, "-", "")
	if val_edited == "" then returnvalue = true end
	if val == "" then returnvalue = false end
	return returnvalue
end

function vexpower_profile_delete(key)
	if key == nil then key = vexpower_profiles_profile_delete end
	if key ~= "" then
		vexpower_profiles[key] = nil
	end
	vexpower_profiles_profile_delete = ""
end

function vexpower_profile_load()
	local key = vexpower_profiles_profile_load
	if key ~= "" then
		vexpower_parameters = vexpower_CopyTable(vexpower_profiles[key])
		vexpower_loaddefaults(false)
	end
end





-- =======================
-- =====TEXT==============
-- =======================
vexpower_panelText_textfield = ""
vexpower_panelText_status = " "

function vexpower_panelText_New()
	local newname = vexpower_panelText_getNewName()
	vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_default_textfield)
	vexpower_panelText_textfield = newname
	vexpower_panelText_status = "New textfield '"..newname.."' created successfully"
	vexpower_panelText_testmode()
end

function vexpower_panelText_Clone()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		local newname = vexpower_panelText_getNewName()
		vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield])
		vexpower_panelText_status = "New textfield '"..newname.."' created successfully (Clone of "..vexpower_panelText_textfield..")"
		vexpower_panelText_textfield = newname
		vexpower_panelText_testmode()
	else
		vexpower_panelText_status = "ERROR: Couldn't clone textfield. Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
end

function vexpower_panelText_Delete()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] = nil
		vexpower_energytext[vexpower_panelText_textfield]:Hide()
		vexpower_energytext[vexpower_panelText_textfield] = nil
		vexpower_panelText_status = "Textfield '"..vexpower_panelText_textfield.."' deleted successfully"
		vexpower_panelText_textfield = vexpower_panelText_getFirstTextfield()
		vexpower_panelText_testmode()
	else
		vexpower_panelText_status = "ERROR: Couldn't delete textfield. Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
end

function vexpower_panelText_getFirstTextfield()
	local number = 1
	local found = false
	local exist = false
	
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil then
			exist = true
		end
	end
	
	if exist then
		while not(found) do
			local name = tostring(number)
			if vexpower_parameters["frame"]["energy"]["text"][name] ~= nil then
				found = true
			else
				number = number + 1
			end
		end
		return tostring(number)
	else
		return ""
	end
end

function vexpower_panelText_getNewName()
	local number = 1
	local found = false
	while not(found) do
		local name = tostring(number)
		if vexpower_parameters["frame"]["energy"]["text"][name] == nil then
			found = true
		else
			number = number + 1
		end
	end
	return tostring(number)
end

function vexpower_panelText_getDisabled()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return false
	else
		return true
	end
end

function vexpower_panelText_setDataDirect(data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data] = key
	end
end

function vexpower_panelText_getDataDirect(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data]
	end
end

function vexpower_panelText_getDataColor(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data]
	end
end

function vexpower_panelText_setDataColor(data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data] = key
	end
end

function vexpower_panelText_getDataShadow(folder, data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data]
		else
			if folder == "color" and data == "a" then
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]*100
			else
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]
			end
		end
	end
end

function vexpower_panelText_setDataShadow(folder, data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data] = key
		else
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data] = key
		end
	end
end

function vexpower_panelText_getTextList()
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if key ~= "profilelist" then
			returnvalue[key]=key
			timer = timer + 1
		end
	end
	
	if timer == 0 then
		returnvalue[""] = "No textfields created"
	end
	
	return returnvalue
end

function vexpower_panel_TagInsert(text, tag)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"] = vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"].."["..tag.."] "
	end
end